#ifndef __ABLIB_CMDLINE_H__
#define __ABLIB_CMDLINE_H__

#include <vector>
#include <map>
/**
* ǗD炩߃IvVݒ肵ĂD
* -f܂--file݂Ȍ`T|[gD
* R[hSRvȂ̂œKɏĂ܂D
*/

namespace ablib{

class CmdLine{
private:
	/// ̂̂̃IvVi[
	struct opt{
		opt() : needed(false),needarg(false),check(false){}
		ablib::string arg;
		bool needarg,needed;
		bool check;
	};

	/// ܂Ƃ߂Ă݂
	struct options{
		std::map<TCHAR,opt> chararg;
		std::map<ablib::string,opt> strarg;
		opt &operator[](TCHAR c){return chararg[c];}
		opt &operator[](const ablib::string &s){return strarg[s];}
		void add(TCHAR opt,bool optarg);
		void add(const ablib::string &opt,bool optarg);
	};

public:
	CmdLine(const TCHAR *arg) : m_arg(arg){}
	~CmdLine(){}
	ablib::string GetArgv(int i) const{return m_argv[i];}
	size_t GetArgc() const{return m_argv.size();}

	void opt_add(TCHAR opt,bool optarg){m_options.add(opt,optarg);}//1IvV
	void opt_add(const TCHAR *opt,bool optarg){m_options.add(opt,optarg);}//IvV
	bool parse();
	const TCHAR *errmsg(){return m_errmsg.c_str();}

	const TCHAR *OptionArg(const ablib::string &opt) const{return m_options[opt].arg.c_str();}
	const TCHAR *OptionArg(TCHAR opt) const{return m_options[opt].arg.c_str();}
	bool IsChecked(const ablib::string &opt) const{return m_options[opt].check;}
	bool IsChecked(TCHAR opt) const{return m_options[opt].check;}

private:
	ablib::string m_arg,m_errmsg;
	std::vector<ablib::string> m_argv;

	mutable options m_options;

	const TCHAR *NextToken(const TCHAR *p);

private:
	NOCOPY(CmdLine);
};

}//namespace ablib

#endif //__ABLIB_CMDLINE_H__

