#ifndef __ABLIB_ARG_H__
#define __ABLIB_ARG_H__

#include "macro/cat.h"
#include "macro/repeat.h"
#include "function.h"

namespace ablib{

template<int N> class arg{};

}

namespace{

#define ABLIB_ARG_CREATE(n) ablib::arg<n> _ ## n;
#define ABLIB_ARG_CREATES(n) ABLIB_REPEAT(n,ABLIB_ARG_CREATE) ablib::arg<n> _ ## n;
ABLIB_ARG_CREATES(ABLIB_FUNCTION_ARGC)

#undef ABLIB_ARG_CREATES
#undef ABLIB_ARG_CREATE

}

#endif //__ABLIB_ARG_H__

