#ifndef __ABLIB_FUNCTION_H__
#define __ABLIB_FUNCTION_H__

#include "macro/repeat.h"
#include "macro/cat.h"
#include "macro/calc.h"
//#include "typetraits.h"

namespace ablib{

//ő̐i̐ŃG[o܂DDj
#ifndef ABLIB_FUNCTION_ARGC
#define ABLIB_FUNCTION_ARGC 15
#endif

/* ֐[߂NXDfunction2<double,int,char*>intchar*󂯎doubleԂ֐łD
֐|C^&łȂĂ悤ɂĂ܂D

C++WȂĖāCVC++7.0ŃRpCo悤ɁCƂlĂ܂D
*/

//functionNX[D
#define ABLIB_FUNCTION_CREATE(n)																	\
namespace function_detail{																			\
/* ֐i[NX̊NXD*/																	\
template<typename R ABLIB_TEMPLATE_PARAMS(n)> class functionImpl ## n {								\
public:																								\
	virtual R operator()(ABLIB_FUNC_PARAMS(n)) = 0;													\
	virtual functionImpl ## n *Clone() const = 0;													\
	virtual ~functionImpl ## n(){}																	\
};																									\
																									\
/* ֐IuWFNg */																				\
template<class Parentfunction,typename Fun> class functionHandler ## n :							\
	public functionImpl ## n <typename Parentfunction::ResultType ABLIB_PARENTPARAMS(n) >{			\
public:																								\
	typedef typename Parentfunction::ResultType ResultType;											\
	functionHandler ## n(const Fun &fun) : m_fun(fun){};											\
	ResultType operator()(ABLIB_FHANDLAR_OP_ARGS(n)){return m_fun(ABLIB_FUNC_ARGS(n));}				\
	functionHandler ## n *Clone() const{return new functionHandler ## n(*this);}					\
private:																							\
	Fun m_fun;																						\
};																									\
																									\
/* ֐|C^ */																					\
template<class Parentfunction> class TruefunctionHandler ## n : 									\
	public functionImpl ## n<typename Parentfunction::ResultType ABLIB_PARENTPARAMS(n) >{			\
public:																								\
	typedef typename Parentfunction::ResultType ResultType;											\
	typedef ResultType (* Fun)(ABLIB_FHANDLAR_OP_ARGS(n));											\
	TruefunctionHandler ## n(const Fun f) : m_fun(f){}												\
	ResultType operator()(ABLIB_FHANDLAR_OP_ARGS(n)){return m_fun(ABLIB_FUNC_ARGS(n));}				\
	TruefunctionHandler ## n *Clone() const{return new TruefunctionHandler ## n(m_fun);}			\
private:																							\
	Fun m_fun;																						\
};																									\
																									\
/* NX̃o֐ */																			\
template<class Parentfunction,typename PointerToMemFun,typename PointerToObj>						\
	class MemFunHandler ## n :																		\
	public functionImpl ## n<typename Parentfunction::ResultType ABLIB_PARENTPARAMS(n)>{			\
public:																								\
	typedef typename Parentfunction::ResultType ResultType;											\
	MemFunHandler ## n(PointerToMemFun fun,const PointerToObj &obj) : m_obj(obj),m_fun(fun){};		\
	ResultType operator()(ABLIB_FHANDLAR_OP_ARGS(n)){return ((*m_obj).*m_fun)(ABLIB_FUNC_ARGS(n));}	\
	MemFunHandler ## n *Clone() const{return new MemFunHandler ## n(m_fun,m_obj);}					\
private:																							\
	PointerToMemFun m_fun;																			\
	PointerToObj m_obj;																				\
};																									\
}																									\
																									\
template<typename R ABLIB_TEMPLATE_PARAMS(n)> class function ## n{									\
public:																								\
	typedef R ResultType;																			\
	ABLIB_TYPEDEFS(n)																				\
	ResultType operator()(ABLIB_FUNC_PARAMS(n)){return (*m_impl)(ABLIB_FUNC_ARGS(n));};				\
																									\
	function ## n() : m_impl(NULL){}																\
	function ## n(const function ## n &obj) : m_impl(obj.m_impl ? obj.m_impl->Clone() : NULL){}		\
																									\
	function ## n(R (*fun)(ABLIB_FUNC_PARAMS(n))) : 												\
		m_impl(new function_detail::TruefunctionHandler ## n<function ## n>(fun)){}					\
																									\
	template<typename Fun>function ## n(Fun &fun) :													\
		m_impl(new function_detail::functionHandler ## n<function ## n,Fun>(fun)){}					\
																									\
	template<typename PointerToMemFun,typename PointerToObj>function ## n(							\
		PointerToMemFun fun,const PointerToObj &obj													\
	) : m_impl(new function_detail::MemFunHandler ## n<function ## n,PointerToMemFun,PointerToObj>(fun,obj)){};	\
																									\
	~function ## n(){delete m_impl;}																\
																									\
	function ## n &operator=(const function ## n &obj){												\
		Impl *New;																					\
		if(obj.m_impl){																				\
			New = obj.m_impl->Clone();																\
			if(New){																				\
				delete m_impl;																		\
				m_impl = New;																		\
			}																						\
		}else{																						\
			delete m_impl;																			\
			m_impl = NULL;																			\
		}																							\
		return *this;																				\
	}																								\
	operator bool() const{return (m_impl != NULL);}													\
private:																							\
	typedef function_detail::functionImpl ## n<R ABLIB_TEMPLATE_ARGS(n)> Impl;						\
	Impl *m_impl;																					\
};																									\

#define ABLIB_FUNC_PARAMS(n)
#define ABLIB_FUNC_ARGS(n)
#define ABLIB_TEMPLATE_PARAMS(n)
#define ABLIB_TEMPLATE_ARGS(n)
#define ABLIB_TYPEDEFS(n)
#define ABLIB_PARENTPARAMS(n)
#define ABLIB_FHANDLAR_OP_ARGS(n)

//0͓ꈵD
ABLIB_FUNCTION_CREATE(0)

#undef  ABLIB_FUNC_PARAMS
#undef  ABLIB_FUNC_ARGS
#undef  ABLIB_TEMPLATE_PARAMS
#undef  ABLIB_TEMPLATE_ARGS
#undef  ABLIB_TYPEDEFS
#undef  ABLIB_PARENTPARAMS
#undef  ABLIB_FHANDLAR_OP_ARGS

//T1 t1,T2 t2,...,Tn tn
#define ABLIB_FUNC_PARAM(n) T ## n t ## n,
#define ABLIB_FUNC_PARAMS(n) ABLIB_REPEAT_4(n,ABLIB_FUNC_PARAM) T ## n t ## n

//t1,t2,...,tn
#define ABLIB_FUNC_ARG(n) t ## n,
#define ABLIB_FUNC_ARGS(n) ABLIB_REPEAT_4(n,ABLIB_FUNC_ARG) t ## n

//, typename T1,typename T2,...,typename Tn
#define ABLIB_TEMPLATE_PARAM(n) typename T ## n,
#define ABLIB_TEMPLATE_PARAMS(n) , ABLIB_REPEAT_4(n,ABLIB_TEMPLATE_PARAM) typename T ## n

//,T1,T2,...,Tn
#define ABLIB_TEMPLATE_ARG(n) T ## n,
#define ABLIB_TEMPLATE_ARGS(n) , ABLIB_REPEAT_4(n,ABLIB_TEMPLATE_ARG) T ## n

//typedef T1 Param1,...,typedef Tn Paramn
#define ABLIB_TYPEDEF(n) typedef T ## n Param ## n;
#define ABLIB_TYPEDEFS(n) ABLIB_REPEAT_4(n,ABLIB_TYPEDEF) ABLIB_TYPEDEF(n)

//,typename Parenfunction::Param1,...,typename Parentfunction:Paramn
#define ABLIB_PARENTPARAM(n) typename Parentfunction::Param ## n,
#define ABLIB_PARENTPARAMS(n) , ABLIB_REPEAT_4(n,ABLIB_PARENTPARAM) typename Parentfunction::Param ## n

//typename Parenfunction::Param1 t1,...,typename Parentfunction:Paramn tn
#define ABLIB_FHANDLAR_OP_ARG(n) typename Parentfunction::Param ## n t ## n,
#define ABLIB_FHANDLAR_OP_ARGS(n) ABLIB_REPEAT_4(n,ABLIB_FHANDLAR_OP_ARG) typename Parentfunction::Param ## n t ## n

ABLIB_REPEAT(ABLIB_FUNCTION_ARGC,ABLIB_FUNCTION_CREATE)

//n[
#undef ABLIB_FUNC_PARAM
#undef ABLIB_FUNC_PARAMS
#undef ABLIB_FUNC_ARG
#undef ABLIB_FUNC_ARGS
#undef ABLIB_TEMPLATE_PARAM
#undef ABLIB_TEMPLATE_PARAMS
#undef ABLIB_TEMPLATE_ARG
#undef ABLIB_TEMPLATE_ARGS
#undef ABLIB_TYPEDEF
#undef ABLIB_TYPEDEFS
#undef ABLIB_PARENTPARAM
#undef ABLIB_PARENTPARAMS
#undef ABLIB_FHANDLAR_OP_ARG
#undef ABLIB_FHANDLAR_OP_ARGS
#undef ABLIB_FUNCTION_CREATE


}

#endif //__ABLIB_FUNCTION_H__

