#ifndef __ABLIB__STACK_H__
#define __ABLIB__STACK_H__

#include "ablib.h"
#include "vector.h"

namespace ablib{

/** stackBvstackB
* ܂dequeNXĂȂƂ肠vector{ɁB
*/

template<class T,class Cont = ablib::vector<T> >class stack
{
public:
	typedef Cont::size_type size_type;
	stack(void) : c(){};
	~stack(void){};

	bool empty() const{return c.empty();}
	size_type size() const{return c.size();}
	T &top() const{return c.back();}
	void push(const T &obj){return c.push_back(obj);}
	void pop(){c.pop_back();}

private:
	Cont c;

};

} //namespace ablib

#endif //__ABLIB_STACK_H__

