#ifndef __ABLIB_WINDOW_EDIT_STRUCT_H__
#define __ABLIB_WINDOW_EDIT_STRUCT_H__

namespace ablib{
namespace window{
namespace edit{

/*
Ȃ[cc\̂łD
*/

//킩ˁi΁j
struct POS{
	int lineno;
	int column;
	POS(int l,int c) : lineno(l),column(c){};
	POS() : lineno(0),column(0){};
	bool operator< (const POS &obj) const{return (lineno < obj.lineno || (lineno == obj.lineno && column < obj.column));}
	bool operator> (const POS &obj) const{return (lineno > obj.lineno || (lineno == obj.lineno && column > obj.column));}
	bool operator==(const POS &obj) const{return (lineno == obj.lineno && column == obj.column);}
	bool operator!=(const POS &obj) const{return !operator==(obj);}
};

//ƓȂ񂾂ǂˁ[D
struct XY{
	int x;
	int y;
	XY(int cx,int cy) : x(cx),y(cy){};
	XY() : x(0),y(0){};
	bool operator< (const XY &obj) const{return (y < obj.y || (y == obj.y && x < obj.x));}
	bool operator> (const XY &obj) const{return (y > obj.y || (y == obj.y && x > obj.x));}
	bool operator==(const XY &obj) const{return (x == obj.x && y == obj.y);}
	bool operator!=(const XY &obj) const{return !operator==(obj);}
};

//CAEgf[^D
struct LayoutData{
	int line;
	int offset;
	int length;
	LayoutData(){};
	LayoutData(int l,int o,int len):line(l),offset(o),length(len){};
};

//̈ʒuƏꏊD
struct PosLen{
	int pos;
	int len;
	PosLen(int p,int l) : pos(p),len(l){};
	PosLen(){};
};

}//namespace edit
}//namespace window
}//namespace ablib

#endif//__ABLIB_WINDOW_EDIT_STRUCT_H__

