#ifndef __ABLIB_SYSTEM_POWER_H__
#define __ABLIB_SYSTEM_POWER_H__

#include "system.h"
#include <vector>

namespace ablib{
namespace system{


class Power{
public:
	Power(){}
	~Power(){}
	bool Reboot();
	bool LogOff();
	bool ShutDown();
	bool PowerOff();

private:
	bool GetPrivileges();
	System m_system;
};

}//namespace system
}//namespace ablib

#endif //__ABLIB_SYSTEM_POWER_H__

