#ifndef __ABLIB_SYSTEM_SYSTEM_H__
#define __ABLIB_SYSTEM_SYSTEM_H__

#include "ablib/string.h"

namespace ablib{
namespace system{

class System{
public:
	System(void){
		m_os.dwOSVersionInfoSize = sizeof(m_os);
		::GetVersionEx(&m_os);
		::GetSystemInfo(&m_system);
	}
	~System(void){}
	bool IsNT(){return m_os.dwPlatformId == VER_PLATFORM_WIN32_NT;}
	bool Is98(){return m_os.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS;}
	bool Is64bit();
	bool IsWow64();

private:
	OSVERSIONINFO m_os;
	SYSTEM_INFO m_system;
};

}//namespace system
}//namespace ablib

#endif //__ABLIB_SYSTEM_SYSTEM_H__

