#ifndef __ZLIB_ZIP_H__
#define __ZLIB_ZIP_H__

#include <functional>
#include "../ablib/Lock.h"

/*
* zip̉𓀂SDGW͖ܘ_zlib
*/

namespace zlib{

class Zip : ablib::Lock{
public:
	Zip();
	~Zip(){}
	bool DeCompress(const TCHAR *fname,const TCHAR *dir);
//	static bool Compress(const TCHAR *dir);
	typedef std::function<bool (const TCHAR*)> OutputMessageFunction;
	void SetOutputMessageFunction(const OutputMessageFunction msgfunc){m_msgfunc = msgfunc;}
	void Stop(){LOCK l(this);m_stop = true;}

private:
	OutputMessageFunction m_msgfunc;
	bool m_stop;

	static bool CreateDirectoryReflex(const ablib::string &strPath){return CreateDirectoryReflex(strPath.c_str());}
	static bool CreateDirectoryReflex(const TCHAR *str);
};

}// namespace zlib

#endif //__ZLIB_ZIP_H__

